"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_mockito_1 = require("ts-mockito/lib/ts-mockito");
var apiConfiguration_1 = require("../configuration/apiConfiguration");
// Initialisation
var componentCode = -69981087;
var stateMachineCode = -829536631;
var eventCode = 9;
var messageType = "XComponent.HelloWorld.UserObject.SayHello";
var routingKey = "input.1_0.HelloWorldMicroservice.HelloWorld.HelloWorldManager";
var guiExample = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx";
var sessionData = "sessiondata";
function getHeader(visibility) {
    var header = {
        "StateMachineCode": stateMachineCode,
        "ComponentCode": componentCode,
        "EventCode": eventCode,
        "IncomingEventType": 0,
        "MessageType": messageType,
        "PublishTopic": (!visibility) ? undefined : guiExample,
        "SessionData": sessionData
    };
    return header;
}
var jsonMessage = { "Name": "MY NAME" };
function getCorrectData(visibility) {
    return {
        event: {
            "Header": getHeader(visibility),
            "JsonMessage": JSON.stringify(jsonMessage)
        },
        routingKey: routingKey
    };
}
function getCorretWebsocketInputFormat(visibility) {
    var correctData = getCorrectData(visibility);
    var correctWebsocketInputFormat = correctData.routingKey + " " + correctData.event.Header.ComponentCode
        + " " + JSON.stringify(correctData.event);
    return correctWebsocketInputFormat;
}
var stateMachineRef = {
    "StateMachineId": 1,
    "StateMachineCode": stateMachineCode,
    "ComponentCode": componentCode,
};
var correctDataForSMRef = {
    event: {
        "Header": {
            "StateMachineId": stateMachineRef.StateMachineId,
            "StateMachineCode": stateMachineRef.StateMachineCode,
            "ComponentCode": stateMachineRef.ComponentCode,
            "EventCode": eventCode,
            "IncomingEventType": 0,
            "MessageType": messageType,
            "SessionData": sessionData
        },
        "JsonMessage": JSON.stringify(jsonMessage)
    },
    routingKey: routingKey
};
var corretWebsocketInputFormatForSendSMRef = correctDataForSMRef.routingKey + " " + correctDataForSMRef.event.Header.ComponentCode
    + " " + JSON.stringify(correctDataForSMRef.event);
var apiConfiguration = ts_mockito_1.mock(apiConfiguration_1.DefaultApiConfiguration);
ts_mockito_1.when(apiConfiguration.getComponentCode(ts_mockito_1.anyString())).thenCall(function (componentName) {
    if (!componentName) {
        throw new Error();
    }
    return componentCode;
});
ts_mockito_1.when(apiConfiguration.getStateMachineCode(ts_mockito_1.anyString(), ts_mockito_1.anyString())).thenCall(function (componentName, stateMachineName) {
    if (!componentName || !stateMachineName) {
        throw new Error();
    }
    return stateMachineCode;
});
ts_mockito_1.when(apiConfiguration.getPublisherDetails(ts_mockito_1.anyNumber(), ts_mockito_1.anyNumber(), ts_mockito_1.anyString())).thenCall(function () {
    return {
        eventCode: eventCode,
        routingKey: routingKey
    };
});
ts_mockito_1.when(apiConfiguration.containsStateMachine(ts_mockito_1.anyString(), ts_mockito_1.anyString())).thenCall(function (componentName, stateMachineName) {
    if (!componentName || !stateMachineName) {
        return false;
    }
    else {
        return true;
    }
});
ts_mockito_1.when(apiConfiguration.containsPublisher(ts_mockito_1.anyNumber(), ts_mockito_1.anyNumber(), ts_mockito_1.anyString())).thenCall(function (compCode, stmCode) {
    return compCode === componentCode && stmCode === stateMachineCode;
});
var returnObject = {
    configuration: ts_mockito_1.instance(apiConfiguration),
    jsonMessage: jsonMessage,
    messageType: messageType,
    correctData: getCorrectData(false),
    getCorretWebsocketInputFormat: getCorretWebsocketInputFormat,
    stateMachineRef: stateMachineRef,
    corretWebsocketInputFormatForSendSMRef: corretWebsocketInputFormatForSendSMRef,
    guiExample: guiExample,
    sessionData: sessionData
};
exports.default = returnObject;
//# sourceMappingURL=mockPublisherDependencies.js.map